/** \file
*/

#include "timer.h"

unsigned int SAMPLING_FREQUENCY = 4000;

void AT91F_TC_Open (AT91PS_TC TC_pt, unsigned int Mode, unsigned int TimerId)
{
    /* First Step:  Enable the Timer's clock at PMC level */
    AT91F_PMC_EnablePeriphClock ( AT91C_BASE_PMC, 1 << TimerId ) ;
    /* In order to select TIOA0 we have to disable PA0 and select periph.B
    Peripheral Signal       Corresponding PIO Signal      Multiplexing betw. A or B
    TIOA0               => PA0                            =>Periph.B
    TIOB0               => PA1                            =>Periph.B
    TIOA1               => PA2                            =>Periph.B
    TIOB1               => PA3                            =>Periph.B
    TIOA2               => PA4                            =>Periph.B
    TIOB2               => PA5                            =>Periph.B */
    AT91F_PIO_CfgPeriph (AT91C_BASE_PIOA, 0 , AT91C_PA0_TIOA0);

    /* Second Step: Disable the clock and the interrupts */
    TC_pt->TC_CCR = AT91C_TC_CLKDIS ;
    /* Set the Mode of the Timer Counter */
    TC_pt->TC_CMR = Mode ;
    /* The RC will give you the signal period and (RC-RA) the slot width */
    TC_pt->TC_RC = TIMER_VALUE ;
    TC_pt->TC_RA = (TIMER_VALUE - PULSEWIDTH) ;
    /* Start the timer counter */
    TC_pt->TC_CCR = (AT91C_TC_CLKEN |AT91C_TC_SWTRG ) ;
	//* The ADC convsersions are now started
}
